#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 2A.ml - Clustering
# 
# Ce notebook utilise les données des vélos de Chicago [Divvy Data](https://www.divvybikes.com/system-data). Il s'inspire du challenge créée pour découvrir les habitudes des habitantes de la ville [City Bike](http://www.xavierdupre.fr/app/ensae_projects/helpsphinx/challenges/city_bike.html). L'idée est d'explorer plusieurs algorithmes de clustering et de voire comment trafiquer les données pour les faire marcher et en tirer quelques apprentissages.

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# In[2]:


get_ipython().run_line_magic('matplotlib', 'inline')


# ## Les données
# 
# Elles ont été prétraitées selon le notebook [Bike Pattern 2](http://www.xavierdupre.fr/app/ensae_projects/helpsphinx/notebooks/city_bike_solution_cluster_start.html). Elles représentent la distribution du nombre de vélos partant (*startdist*) et arrivant (*stopdist*). On utilise le clustering pour découvrir les différents usages des habitants de Chicago avec pour intuition le fait que les habitants de Chicago utilise majoritairement les vélos pour aller et venir entre leur appartement et leur lieu de travail. Cette même idée mais à Paris est illustrée par ce billet de blog : [Busy areas in Paris](http://www.xavierdupre.fr/blog/2013-09-26_nojs.html).

# In[3]:


from pyensae.datasource import download_data
file = download_data("features_bike_chicago.zip")
file


# In[4]:


import pandas
features = pandas.read_csv("features_bike_chicago.txt", sep="\t", encoding="utf-8", low_memory=False, header=[0,1])
features.columns = ["station_id", "station_name", "weekday"] + list(features.columns[3:])
features.head()


# ## Exercice 1 : petits clusters
# 
# Que faire des petits clusters ?

# In[5]:





# ## Exercice 2 : autres types de clustering
# 
# On essaye des algorithmes de clustering qui n'imposent pas de choisir un nombre de clusters initial.
# 
# 1. On essaye [DBScan](http://scikit-learn.org/stable/modules/generated/sklearn.cluster.DBSCAN.html). Est-ce que cela fonctionne ? Si non pourquoi ?
# 2. Et si vous savez pourquoi, vous trouverez une solution d'y remédier.

# In[6]: